#include <StdLib.mqh>
//Works "perfectly" on M1 :)

// Global Variables (might be external)
double Lots = 0.1;
double TakeProfit = 100;
double StopLoss = 400;
double TrailingStop = 30;
double LotsDepoForOne = 500;
double LotsDeltaDepo = 500;
double LotsMax = 1000;
double LotsPercent = 10;

int _Magic = 16386;

double pBull;
double cBull;

double Lots(int Choice) { 
   double dLot; 
   // - 
   switch (Choice) {
      case 1:
         int k=LotsDepoForOne; 
         for (double i=2; i<=LotsMax; i++) { 
            k=k+i*LotsDeltaDepo; 
            if (k>AccountFreeMargin()) { 
               dLot=(i-1)/10; break; 
            } 
         } 
         if (dLot<0.1) dLot=0.1; 
         break;
      case 2:
         return(0.1);
      case 3:
         dLot=MathCeil(AccountFreeMargin()/10000*LotsPercent)/10;
   }
   return(dLot);  
}


int start() {
   // Local Variables
   int i, ticket, total, cnt;
   
   pBull = iBullsPower(NULL, 0, 13,PRICE_WEIGHTED,1);
   cBull = iBullsPower(NULL, 0, 13,PRICE_WEIGHTED,0);

   if (pBull > cBull ) {
      //close long position 
      for(cnt=0;cnt<OrdersTotal();cnt++) {
         OrderSelect(cnt,SELECT_BY_POS);
         if (OrderType() == OP_BUY) {
            //if (Bid>(OrderOpenPrice()+TrailingStop*Point)) {
            if (Bid>OrderOpenPrice()) {
  		        OrderClose(OrderTicket(),OrderLots(),Bid,3,Yellow); // close long
  		        return(0);
  		      }
         }
      }
   }
   if (cBull < 0) {
      //close short position
      for(cnt=0;cnt<OrdersTotal();cnt++) {
         OrderSelect(cnt,SELECT_BY_POS);
         if (OrderType() == OP_SELL) {
            //if( Ask<(OrderOpenPrice()-TrailingStop*Point) ) {       
            if (Ask<OrderOpenPrice()) {
        	      OrderClose(OrderTicket(),OrderLots(),Ask,3,Pink); // close short
               return(0);
            }
      	} 
      }
   }
   if (OrdersTotal() < 1) {
      //no current orders. Check for possible short conditions.
      if (pBull > cBull && cBull > 0) {
         OrderSend(Symbol(),OP_SELL,Lots(1),Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",_Magic,0,Red); // open short 
         return(0); 
      }
      //check for long conditions.
      if (cBull<0 ) {
         OrderSend(Symbol(),OP_BUY,Lots(1),Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",_Magic,0,Blue); // open long
         return(0); 
      }
   }
   return(0);  
}

